var hostname = window.location.hostname;

var abort = (function() {
    'use strict';

    var doc = document;
    if (doc instanceof HTMLDocument === false) {
        if (doc instanceof XMLDocument === false ||
            doc.createElement('div') instanceof HTMLDivElement === false) {
            return true;
        }
    }
    if ((doc.contentType || '').lastIndexOf('image/', 0) === 0 ) {
        return true;
    }
    return false;
})();


if ( !abort ) {
    if (hostname === '') {
        hostname = (function() {
            var win = window, hn = '', max = 10;
            try {
                for (;;) {
                    hn = win.location.hostname;
                    if ( hn !== '' ) { return hn; }
                    if ( win.parent === win ) { break; }
                    win = win.parent;
                    if ( !win ) { break; }
                    if ( (max -= 1) === 0 ) { break; }
                }
            } catch(ex) {
            }
            return hn;
        })();
    }
    // Don't inject if document is from local network.
    abort = /^192\.168\.\d+\.\d+$/.test(hostname);
}


var getAdblockDomain = function() {
  adblock_installed = true;
};

var getAdblockDomainWithUserID = function(userid) {
  adblock_userid = userid;
};

var getAdblockVersion = function(version) {
  adblock_version = version;
};

(function() {
    'use strict';

    if ( abort ) {
      return;
    }

    // Only for dynamically created frames and http/https documents.
    if ( /^(https?:|about:)/.test(window.location.protocol) !== true ) {
      return;
    }

    var doc = document;
    var parent = doc.head || doc.documentElement;
    if ( parent === null ) {
      return;
    }

    var scriptText = [];

    // Have the script tag remove itself once executed (leave a clean
    // DOM behind).
    var cleanup = function() {
        var c = document.currentScript, p = c && c.parentNode;
        if ( p ) {
            p.removeChild(c);
        }
    };

    if ('adblockprotect.com' === document.location.hostname ||
        'dev.adblockprotect.com' === document.location.hostname) {
      chrome.storage.local.get('userid', function (response) {
        var adblock_user_id = response['userid'];
        var adblock_version = chrome.runtime.getManifest().version;
        var elem = document.createElement('script');
        var scriptToInject = '(' + getAdblockDomain.toString() + ')();' +
            '(' + cleanup.toString() + ')();' +
            '(' + getAdblockDomainWithUserID.toString() + ')(\'' + adblock_user_id + '\');' +
            '(' + getAdblockVersion.toString() + ')(\'' + adblock_version + '\');';
        elem.appendChild(document.createTextNode(scriptToInject));
        try {
            (document.head || document.documentElement).appendChild(elem);
        } catch(ex) {
        }
      });
    }
})();

var run_bandaids = function()
{
  if (("adblockprotect.com" === document.location.hostname ||
            "dev.adblockprotect.com" === document.location.hostname) &&
           (window.top === window.self))
  {
    apply_bandaid_for = "adblockprotect";
  }
  var bandaids = {
    adblockprotect : function()
    {
      BGcall('get_adblock_user_id', function (adblock_user_id ) {
        if (adblock_user_id)
        {
          var elemDiv = document.createElement("div");
          elemDiv.id = "adblock_user_id";
          elemDiv.innerText = adblock_user_id;
          elemDiv.style.display = "none";
          document.body.appendChild(elemDiv);
        }
      });
    },
  }; // end bandaids

  if (apply_bandaid_for)
  {
    log("Running bandaid for " + apply_bandaid_for);
    bandaids[apply_bandaid_for]();
  }

};
